// C Source File
// Created 6/8/2003; 3:05:29 PM

/*
    The Urinal Game
    Copyright (C) 2003 Angelboy

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#define USE_TI92PLUS          // Compile for TI-92 Plus

#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
  clrscr();
  int curLev = 1, x = 1, *temp = 0, key = 0, i = 0;
  unsigned short int door[] = {0xFFFF,0x8001,0x8001,0x83C1,0x87E1,0x87E1,0x83C1,0x8181,0x8181,0x87E1,0x8181,0x8181,0x83C1,0x8241,0x8241,0x8001,0x8001,0x801D,0x8015,0x8015,0x8015,0x8015,0x8015,0x8015,0x801D,0x8001,0x8001,0x8001,0x8001,0x8001,0xFFFF};
  unsigned short int man1[] = {0x0F00,0x1F80,0x1F80,0x1F80,0x1F80,0x0F00,0x0F00,0x0900,0x0900,0x3FC0,0x4020,0x8010,0xA050,0xB0D0,0xB0D0,0xB0D0,0xB0D0,0x9090,0x70E0,0x1F80,0x1F80,0x3FC0,0x3FC0,0x3FC0,0x39C0,0x39C0,0x39C0,0x39C0,0x39C0,0x39C0,0x79E0,0xF9F0};
  unsigned short int man2[] = {0x0F00,0x1F80,0x3FC0,0x3FC0,0x3FC0,0x1F80,0x0F00,0x0600,0x0600,0x3FC0,0x4020,0x8010,0xB0D0,0xB0D0,0xB0D0,0xB0D0,0xB0D0,0x9090,0x70E0,0x1F80,0x1F80,0x30C0,0x2040,0x2F40,0x2940,0x2940,0x2940,0x2940,0x2940,0x2940,0x7FE0,0x7FE0};
  unsigned short int man3[] = {0x0F00,0x1F80,0x1F80,0x1F80,0x1F80,0x1F80,0x0F00,0x0600,0x0900,0x3FC0,0x4020,0x4020,0x50A0,0x50A0,0x50A0,0x50A0,0x50A0,0x50A0,0x70E0,0x1F80,0x1F80,0x1080,0x1680,0x1680,0x1680,0x1680,0x1680,0x1680,0x1680,0x1680,0x1F80,0x3FC0};
  unsigned short int big_guy[] = {0x1F80,0x3FC0,0x3FC0,0x3FC0,0x3FC0,0x3FC0,0x1F80,0x0F00,0x0900,0x7FE0,0x8010,0x8010,0x8010,0xA050,0xA050,0xA050,0xA050,0xA050,0xE070,0x3FC0,0x2040,0x2040,0x4020,0x4020,0x4620,0x8910,0x8910,0x8910,0x8910,0x8910,0x8910,0xF9F0};
  unsigned short int urinal[] = {0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0F00,0x3F00,0x0F00,0x0600,0x7FE0,0x8010,0xBFD0,0xA050,0xA050,0xA050,0xA050,0xA050,0xA050,0xA050,0xB9D0,0x8610,0x70E0,0x0F00,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000};
  unsigned short int invSquare[34]; for(i = 0; i < 34; i++) invSquare[i] = 0xFFFF; //Fill all of them with 0xFFFF: uses less memory
  char open_1[] = {"Urinal 1 is occupied.\nSelect the correct one."}; char open_2[] = {"Urinals 3 and 5 are used.\nCorrect choice?"}; char open_3[] = {"How well will you do here?"}; char open_4[] = {"This should be easier."}; char open_5[] = {"What to do, what to do?"}; char open_6[] = {"Last one..."};
  char right_1[] = {"\nUrinal 6 is the correct answer.  Going there\ngives the most buffer zone for the others."}; char right_2[] = {"\nUrinal 1 gives the most buffer space.\nRemember to keep your eyes on the wall!"}; char right_3[] = {"\n\nTo avoid pairing, avoid being with someone\nelse.This is near the door.  Hurry and leave."};  char right_4[] = {"\n\nBoth urinal 1 and 6 give the same space,\nhowever urinal 1 is further from the door."};   char right_5[] = {"\n\nGood, youre not next to the big guy.  You\nshould never let others question your\nmanliness."};   char right_6[] = {"\n\nThere were only 2 choices. Leave and come\nback later, or go wash your hands. Nice\nchoice."};
  char wrong_1[] = {"\nUrinal 6 is the correct choice.  You should\nalways keep the most buffer zone!"}; char wrong_2[] = {"\nUrinal 1 is correct. This urinal leaves you\nwith no buffer! A man needs his space."}; char wrong_3[] = {"\n\nYour choice puts you between other people.\nToo much pressure! Urinal 6 would work best."}; char wrong_4[] = {"\n\nCreate maximum buffer space!  Urinal 6 gives\nyou a buffer zone, yet urinal 1 blocks from\nthe door."}; char wrong_5[] = {"\n\nYoure with the big guy? People might think\nyou two are together if you choose that one."}; char wrong_6[] = {"\n\nThe only real solution was to walk out, wait\na while, and walk back in."};
  unsigned int level_1[] = {2,0,0,0,0,0}; unsigned int level_2[] = {0,0,2,0,3,0}; unsigned int level_3[] = {2,0,3,0,1,0}; unsigned int level_4[] = {0,0,2,1,0,0}; unsigned int level_5[] = {0,4,0,0,3,2}; unsigned int level_6[] = {0,3,0,1,0,2};

  int answers[] = {5,0,5,0,3,6}; // The correct answer for each of the levels
  unsigned short int *men[] = {urinal,man1,man2,man3,big_guy}; // Each of the sprites to display, based on the array 'level'
  unsigned int *level[] = {level_1,level_2,level_3,level_4,level_5,level_6}; // All of the data for sprites of the level
  char *open[] = {open_1,open_2,open_3,open_4,open_5,open_6}; // All of the opening statements
  char *right[] = {right_1,right_2,right_3,right_4,right_5,right_6}; // Text if they got it right
  char *wrong[] = {wrong_1,wrong_2,wrong_3,wrong_4,wrong_5,wrong_6}; // Text if they got it wrong

  //////////////////
  // Introduction //
  //////////////////
  FontSetSys (F_8x10); // Big font
  DrawStr(20, 0, "The Urinal Game", A_NORMAL); // Title
  FontSetSys (F_6x8); // Medium font
  printf("\n\n\nThe Urinal Game tests your\n   mens room etiquette.\n\n Select the proper urinal\nin each scene.  Good Luck!");
  ngetchx(); // Wait for any keypress
  clrscr(); // Clear the screen and reset the print position

  /////////////////////
  // Display Sprites //
  /////////////////////
  for(curLev = 0; curLev < 6; curLev++) { // Go through each of the levels, when level one: x=0, level 2:x=1, etc.
  	clrscr(); // Clear the screen
  	FontSetSys (F_6x8); // Set the font to medium
  	printf(open[curLev]); // Print the opening statement for the level

  	for(x = 0; x < 6; x++) // Cycle through each of the urinals
  	{
  	  temp = level[curLev];
  		Sprite16(10+20*x, 50, 32, men[temp[x]], LCD_MEM, SPRT_OR); // Display the correct man...or urinal
  	}
    Sprite16(128, 50, 32, door, LCD_MEM, SPRT_XOR); // Show the door
  	Sprite16(8, 49, 34, invSquare, LCD_MEM, SPRT_XOR); // Take the inverse of the first man (or urinal)

    ///////////////
    // Main Loop //
    ///////////////
    x = 0; // Reset the 'x' value, used to see what urinal is going to be inversed
    do { // The main loop, keep on going until they press 'Enter'
    	key = ngetchx(); // See what key is pressed
    	Sprite16(8+20*x, 49, 34, invSquare, LCD_MEM, SPRT_XOR); // Erase the current inverse
    	if ((key == 338) & (x > 0)) x--; // Move the inverse to the left
    	if ((key == 344) & (x < 6)) x++; // Move the inverse to the right
    	Sprite16(8+20*x, 49, 34, invSquare, LCD_MEM, SPRT_XOR); // Place the inverse in the correct location
    } while(key != 13); // Keep looping until they press 'Enter'

    //////////////////////////////
    // Decide if right or wrong //
    //////////////////////////////
    FontSetSys (F_8x10); // Big font
    for (i = 0; i <= 45; i++)	DrawLine (0, i, 160, i, A_REVERSE); // Clear the top half of the screen
    if (x == answers[curLev]) { // If they chose the correct answer

    	DrawStr(48, 0, "Correct!", A_REPLACE); // Display 'Correct'
    	FontSetSys (F_4x6); // Tiny font
    	printf(right[curLev]); // Display the text for that level

    } else { // If they didn't get it right

      if (x < 6) // Did they choose the door??
      {
        if (temp[x] == 0) { // Did they try an open urinal??
      	  DrawStr(58, 0, "Wrong!", A_REPLACE); // Yes, it was open
      	  FontSetSys (F_4x6);
      	  printf(wrong[curLev]); // Tell them what they did wrong

        } else { // No, it was not open
        	DrawStr(66, 0, "Woa!", A_REPLACE);
        	FontSetSys (F_4x6);
        	printf("\n\nWhoa, dude, chill out! This isnt that type of\ngame! Choose an open urinal!"); // Ouch!!
        	curLev--; //Repeat the level
        }
      } else { // They tried to leave??
        DrawStr(62, 0, "Wait!", A_REPLACE);
        FontSetSys (F_4x6);
        printf("\n\nThis problem is not really that difficult.  Be a\nman and get back in there!");
        curLev--;
      }
    }
    ngetchx(); // Wait until they press a key
  }
}